; Timerprogram mit 3 BCD-Schaltern und
; -Stop und Starttaste an B5 (Pin 17)
; -Alarmton bei abgelaufener Zeit an B6 (Pin 18)
; -LED zur Anzeige an B7 (Pin 19)
;
;
; Geschrieben und entworfen von Marcus Pool.
; www.marcus-pool.de
;
; 9. Mai 2001



.include "1200def.inc"
.device AT90S1200

.def TEMP     =r16
.def TEMP2    =r17
.def ZEIT     =r18 
.def HBT2     =r19

.def LowTime  =r20
.def MidTime  =r21
.def HiTime   =r22

.def TIME     =r23

RESET:
 rjmp ANFANG 	;Interuptspruenge
 nop
 rjmp TIMER0
 nop
 
ANFANG:
 clr TEMP         
 out DDRD, TEMP    ;PortD als Eingang

 ser TEMP
 out PORTD, TEMP   ;MOS Pull-up an

 ldi TEMP, 192
 out DDRB, TEMP    ;PortB 0-5 als Eingang

 ldi TEMP, 63
 out PORTB, TEMP   ;Ausgang auf 0
 sbi PORTB,7 
 cbi PORTB,6

START:
 sbic PINB,5		;normal pinB,5
rjmp START



clr LowTime
clr MidTime
clr HiTime




; Abfrage der BCD-Schalter

ABFRAGE:

sbis PIND,0
 sbr LowTime,1
sbis PIND,1
 sbr LowTime,2
sbis PIND,2
 sbr LowTime,4
sbis PIND,3
 sbr LowTime,8

sbis PIND,4
 sbr MidTime,1
sbis PIND,5
 sbr MidTime,2
sbis PIND,6
 sbr MidTime,4
sbis PINB,0
 sbr MidTime,8

sbis PINB,1
 sbr HiTime, 1
sbis PINB,2
 sbr HiTime, 2
sbis PINB,3
 sbr HiTime, 4
sbis PINB,4
 sbr HiTime, 8

; Ist die eingestellte Zeit=0 Test


tst HiTime
 breq TEST
rjmp ON

TEST:
 tst MidTime
 brne ON

 tst LowTime
 brne ON

rjmp  START

; Relais ein

ON:
 cbi PORTB,7
 rcall ZEITSCHLEIFE

; Zeitschleife fuer 1 Sekunde

ZEITSCHLEIFE:

 ldi ZEIT,0x83             
 out tcnt0,ZEIT

 ldi TEMP2,250

 ldi HBT2, 2

 ldi ZEIT,0x03
 out tccr0,ZEIT

 ldi ZEIT,0x02
 out timsk,ZEIT

sei 

SCHLEIFE:
 rjmp SCHLEIFE

TIMER0:
 sbic PORTB,6
 rjmp TIMER200
 ldi ZEIT,0x83
 out tcnt0,ZEIT

 dec TEMP2
 breq IRQ0_1
 reti

IRQ0_1:
 ldi TEMP2,250
 sbis PINB,5	; Abfrage der Start-Stoptaste
 rjmp OFF	; Stoptaste gedrueckt dann ausschalten
 dec HBT2
 breq IRQ0_2
reti

IRQ0_2:
 ldi HBT2,2


; Ende der Sekunde
; Runterzaehlen der Sekunden

 tst Lowtime
 breq MID
 dec LowTime
 breq MID
rjmp ZEITSCHLEIFE

MID:
 tst Midtime
 breq HI
 dec Midtime
 ldi LowTime,10
rjmp ZEITSCHLEIFE
		
HI:
 tst HiTime
 breq OFF
 dec HiTime
 ldi MidTime,9
 ldi LowTime,10
rjmp ZEITSCHLEIFE


OFF:        
 sbi PORTB,7
 sbi PORTB,6

; Einschieben der 200ms fuer Alarmton

WAIT200:
 ldi ZEIT,0x250             ; Alarmzeit ca. 200ms 83
 out tcnt0,ZEIT

 ldi TEMP2,250


 ldi ZEIT,0x03
 out tccr0,ZEIT

 ldi ZEIT,0x02
 out timsk,ZEIT

sei 

SCHLEIFE2:
 rjmp SCHLEIFE2

TIMER200:
 ldi ZEIT,0x83
 out tcnt0,ZEIT

 dec TEMP2
 breq AUS
reti

AUS:
 cbi PORTB,6

rjmp START	;Ende der laestigen Zaehlerei, alles von vorne